#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long ull;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    int n, m;
    ull a[76000];
    ull b[76000];
    for (int h = 0; h < t; h++)
    {
        cin >> n >> m;

        for (ull i = 0; i < n; i++)
        {
            cin >> a[i];
        }
        for (ull i = 0; i < m; i++)
        {
            cin >> b[i];
        }
        ull minx = ULONG_LONG_MAX; 
        ull mod;
        bool o = true;
        sort(a, a + n);
        sort(b, b + m);

        for (ull i = 1; i < n; i++)
        {
            if (a[i] - a[i - 1] < minx)
                minx = a[i] - a[i - 1];
        }
        for (ull i = 0; i < n; i++)
        {
            a[i] = a[i] % minx;
        }
        mod = a[0];
        for (int i = 1; i < n; i++)
        {
            if (a[i] != mod)
            {
                o = false;
            }
        }
        for (ull i = 0; i < m; i++)
        {
            b[i] = b[i] % minx;
        }
        for (ull i = 0; i < m; i++)
        {
            if (b[i] == mod)
            {
                o = false;
            }
        }
        if (o)
        {
            cout << 1;
        }
        else
        {
            cout << 0;
        }
    }
    return 0;
}